#!/usr/local/bin/perl
# Copyright (C)1995-2000 ASH multimedia lab. (http://ash.or.jp/)
#
# create ascii code table (JIS X0201)
# 

# JIS޻ASCIIˤɽ
print "\nJIS޻ASCII\n";

# ɽ
print "JIS  SJIS EUC   ";
print "+0 +1 +2 +3 +4 +5 +6 +7 +8 +9 +A +B +C +D +E +F\n";

$line = "";
$c = 1; # 1ʸ(16ʸ)

for ($c1 = 0x20; $c1 <= 0x7F; $c1++) { # $c11Х

    if ($c == 1) { # Ѵ
        $head = sprintf (" %02X   %02X   %02X  ",
            $c1, $c1, $c1);
    }

    # ʸɽ
    if ($c1 == 0x7F) {
        $line .= "   "; # 
    } else {
        $line .= "  "; # ʸ֤ζ
        $line .= pack("C", $c1);
    }

    if ($c == 16) { # 16ʸܤ1ɽ
        print "$head$line\n";
        $line = "";
        $c = 1;
    } else {
        $c++;
    }
}


# JISʡȾѥʡˤɽ
print "\nJISʡȾѥʡ\n";

# ɽ
print "JIS  SJIS EUC   ";
print "+0 +1 +2 +3 +4 +5 +6 +7 +8 +9 +A +B +C +D +E +F\n";

# ȾѥʤѥʤؤѴơ֥
@han2zen = (
    "","","","","","","","",
    "","","","","","","","",
    "","","","","","","","",
    "","","","","","","","",
    "","","","","","","","",
    "","","","","","","","",
    "","","","","","","","",
    "","","","","","","","",
);

$line = "";
$c = 1; # 1ʸ(16ʸ)

for ($c1 = 0x20; $c1 <= 0x5F; $c1++) { # $c11Х

    if ($c == 1) { # Ѵ
        ($c1_s, $c2_s) = &jis2sjis($c1);
        ($c1_e, $c2_e) = &jis2euc($c1);
        $head = sprintf (" %02X   %02X  %02X%02X ",
            $c1, $c1_s, $c1_e, $c2_e);
    } else {
        $c2_e++;
    }

    # ʸɽ
    $line .= " "; # ʸ֤ζ
    $line .= $han2zen[$c1 - 0x20];

    if ($c == 16) { # 16ʸܤ1ɽ
        print "$head$line\n";
        $line = "";
        $c = 1;
    } else {
        $c++;
    }
}


exit;


# jis ɤ sjis ɤѴ
sub jis2sjis {
    return($_[0] | 0x80, "");
}


# jis ɤ euc ɤѴ
sub jis2euc {
    return(0x8e, $_[0]);
}
